function Spectrum(canvas, meter){
this.meterCanvas = meter;
this.meterCanvasCtx = this.meterCanvas.getContext("2d");
this.mainCanvasCtx = canvas.getContext("2d");
this.mainCanvas = canvas;
this.colorScale = new chroma.ColorScale({
        //colors: ['#5C4D6B', '#536887', '#3D839A', '#259FA1', '#35B89B', '#67CF8A', '#A3E275', '#E7F065' ],
        //colors: ['#5C4D6B', '#3F627B', '#1C757A', '#2A8569', '#5B8F4F', '#91933B', '#C89140', '#F78B65' ],
        colors: [ '#000000', '#0B16B5', '#FFF782', '#EB1250' ],
        // colors:['#000000', '#ff0000', '#ffff00', '#ffffff'],
        // positions:[0, .125, 0.25, 0.375, 0.5, 0.625, 0.75, 1],
        positions: [ 0, 0.4, 0.68, 0.85 ],
        mode:'rgb',
        limits:[0, 256]
    });
this.fftArrayIdx = 0;
this.binwidth = 9;
this.fStartIdx = 1;
this.Freq_From = 450;
this.Freq_To = 1050;
this.fftArrayIdx = 200;
this.FFTSize = 32768;
this.Fs = 44100;
this.YLabelLength = 0;
this.SpectrumBarGraphCanvasSettings = new CanvasJS.Chart("SpektrumWrapper",
{
 backgroundColor: "#000",
 axisX:{
  labelAngle: 90, 
  lineThickness: 1.5,
  tickThickness: 1.5,
  tickLength: 10,
   title: " ",
   minimum: this.Freq_From,
   maximum: this.Freq_To,
   tickColor : "white",
   labelFontColor : "white",
   labelFontFamily: "Arial",
   labelFontSize: 14.5,
   labelFormatter: this.formatXLabel.bind(this),
  stripLines:[
      {
        labelFormatter: this.stripLabelFormat.bind(this),
        labelPlacement:"outside",
        labelBackgroundColor: "black",
        label: "690",
        value:690,
        thickness:2
      },
       {
       labelFormatter: this.stripLabelFormat.bind(this),
        labelPlacement:"outside",
        labelBackgroundColor: "black",
        label: "800",
        value:800,
        thickness:2
      },
       {
       labelFormatter: this.stripLabelFormat.bind(this),
        labelPlacement:"outside",
        labelBackgroundColor: "black",
        label: "900",
        value:900,
        thickness:2
      }
      ]
  },
  axisY2:{
    lineThickness: 1,
    tickThickness: 1,
    tickLength:0,
   minimum: -120,
   maximum: 0,
   interval: 30,
   tickColor : "white",
   labelFontColor : "white",
   labelFontSize: 14.5,
   labelFontFamily: "Arial",
   gridThickness: 1,
   labelFormatter: this.formatYLabel.bind(this)
 },
 data: [
      {
        //axisXType: "secondary",
        axisYType: "secondary",
        type: "line",
        markerSize: 0
      }
      ],
toolTip:{
    contentFormatter : this.toolTipFormater.bind(this)
 }

});
this.SpectrumBarGraphCanvas = document.querySelector('#SpektrumWrapper canvas');
this.setDecibel(-140,-30)
this.reset();
}

Spectrum.prototype.stripLabelFormat = function(e){
 return this.formatFreq(e.stripLine.value)+" "+this.formatUnits(e.stripLine.value)+"--";
};

Spectrum.prototype.toolTipFormater = function(e) {
  var dPx = e.entries[0].dataPoint.x;
  var dPy = e.entries[0].dataPoint.y;
  return this.formatFreq(dPx)+" "+this.formatUnits(dPx) +"   " + dPy.toFixed(2)+" dB";
};

Spectrum.prototype.formatYLabel = function(e) {
  return e.value+" dB"; 
};

Spectrum.prototype.formatXLabel = function(e) {
	return this.formatFreq(e.value)+" "+this.formatUnits(e.value)+"--"; 
};

Spectrum.prototype.freqToIndex = function(freq,nyquist,FFTSize){
	 return Math.round(freq/nyquist * FFTSize);
}

Spectrum.prototype.formatFreq = function(freq) {
  return (freq >= 1000 ? (freq/1000).toFixed(1) : Math.round(freq));
}

Spectrum.prototype.formatUnits = function(freq) {
  return (freq >= 1000 ? "kHz" : "Hz");
}

Spectrum.prototype.indexToFreq = function(idx){
  return Math.floor(this.Fs/this.FFTSize*idx);
}

//this fucktion chnters FFT bin width to pixel i
Spectrum.prototype.getWidthOfText = function(txt){
  var offset = 11;
  if(txt.length === 6){
    offset = 17;
  }else{
    offset = 11;
  }
  var Opera = (navigator.userAgent.match(/Opera|OPR\//) ? true : false);
    // Create a dummy canvas (render invisible with css)
  var c=document.createElement('canvas');
  // Get the context of the dummy canvas
  var ctx=c.getContext('2d');
  // Set the context.font to the font that you are using
  ctx.font = "14px Arial";
  // Measure the string 
  // !!! <CRUCIAL>  !!!
  var length = Math.ceil(ctx.measureText(txt).width)+offset;
  // !!! </CRUCIAL> !!!
this.waterCanvas = document.createElement("canvas");
this.waterCanvas.width = this.mainCanvas.width-length;
this.waterCanvas.height = 550;
this.wctx = this.waterCanvas.getContext("2d");
this.tempCanvas = document.createElement("canvas");
this.tempCtx = this.tempCanvas.getContext("2d");
this.tempCanvas.width=this.mainCanvas.width-length;
this.tempCanvas.height=this.mainCanvas.height;
this.width = this.mainCanvas.width-length;
this.height = this.mainCanvas.height;
this.mainCanvasCtx.clearRect(0,0,this.mainCanvas.width,this.mainCanvas.height)
 };

Spectrum.prototype.getAverageVolume = function(data){
    var values = 0;
        var average;

        var length = data.length;

        // get all the frequency amplitudes
        for (var i = 0; i < length; i++) {
            values += data[i];
        }

        average = values / length;
        return average;
}

Spectrum.prototype.drawMeter = function(magdB) {
    var h = this.meterCanvas.height;
    var w = this.meterCanvas.width;
    var grad = this.meterCanvasCtx.createLinearGradient(w/10,h*0.2,w/10,h*0.95);
        grad.addColorStop(0,'red');
        grad.addColorStop(-6/-72,'yellow');
        grad.addColorStop(1,'green');
        //fill the background
        this.meterCanvasCtx.fillStyle = '#555';
        this.meterCanvasCtx.fillRect(0,0,w,h);
        this.meterCanvasCtx.fillStyle = grad;
        //draw the rectangle
        this.meterCanvasCtx.fillRect(0,h*(magdB/-72),w,h);
};

Spectrum.prototype.draw = function(FFT_data, dB_Data) {
  var dPs = [];
	if(this.tempCtx){
  this.tempCtx.drawImage(this.waterCanvas,0,0,this.width,this.height);
	for(var i=0;i<this.width;++i){
		var pt = Math.floor(this.fStartIdx + this.fftArrayIdx/this.width*i);
		var val = FFT_data[pt];
    var dB = dB_Data[pt];
    var freq = this.indexToFreq(pt);
    if(i===0){
     if(freq !== this.Freq_From){
      dPs.push({x : this.Freq_From, y: dB});
     }
    }else if(i==this.width-1){
       if(freq !== this.Freq_To){
         dPs.push({x : this.Freq_To, y: dB});
      }
    }else{
        if(freq !== lastFreq){
            dPs.push({x : freq, y: dB});
        }
    }
    lastFreq = this.indexToFreq(pt);
    if(val){
		this.wctx.fillStyle = this.colorScale.getColor(val).hex();
		this.wctx.fillRect(i, 1, 1, 1);
    }
	}
  this.SpectrumBarGraphCanvasSettings.options.data[0].dataPoints = dPs;
  this.SpectrumBarGraphCanvasSettings.render(); 
 	this.wctx.drawImage(this.tempCanvas, 0, 0, this.width, this.height, 0, 1, this.width, this.height);
 	this.mainCanvasCtx.drawImage(this.waterCanvas,0,0,this.width,this.height);
 }
};


Spectrum.prototype.setFFTsize = function(FFTSize) {
	this.FFTSize = FFTSize;
	this.reset();
};

Spectrum.prototype.setSampleRate = function(Fs) {
	this.Fs = Fs;
	this.reset();
};

Spectrum.prototype.setFrequency = function(Freq_From, Freq_To) {
	this.Freq_From = Freq_From;
	this.Freq_To = Freq_To;
  this.SpectrumBarGraphCanvasSettings.options.axisX.minimum = Freq_From;
  this.SpectrumBarGraphCanvasSettings.options.axisX.maximum = Freq_To;
	this.reset();
};

Spectrum.prototype.setDecibel = function(dB_From, dB_To) {
  this.getWidthOfText(String(Math.round(dB_From)+ " dB"))
  this.SpectrumBarGraphCanvasSettings.options.axisY2.minimum = dB_From;
   this.SpectrumBarGraphCanvasSettings.options.axisY2.maximum = dB_To;
}

Spectrum.prototype.setLabelInterval = function(axisX_inter, axisY_inter) {
  if(axisX_inter >= 0)this.SpectrumBarGraphCanvasSettings.options.axisX.interval = axisX_inter;
  if(axisY_inter >= 0) this.SpectrumBarGraphCanvasSettings.options.axisY2.interval = axisY_inter;
}


Spectrum.prototype.calcDrawValues = function(){
	var binwidth = this.Fs/this.FFTSize;
	this.fStartIdx = this.Freq_From/binwidth;
	var fEndIdx = this.Freq_To/binwidth;
	var bw = fEndIdx-this.fStartIdx+1;
	this.fftArrayIdx = bw;
}

Spectrum.prototype.setPeakFilterOffs = function(avgPwr, pwrOffs) {
  var val = avgPwr+30;

 var lines = [
      /*{
        color:"#30a55c",
        labelBackgroundColor: "black",
        label: "P. Filter "+String(Math.round(startValue)),
        value:startValue,
        thickness:1,
      },*/
       {
        color:"#fd2749",
        labelBackgroundColor: "black",
        label: "D. Squelch "+String(Math.round(val+pwrOffs)),
        value:val+pwrOffs,
        thickness:1
      }
    ]
  this.SpectrumBarGraphCanvasSettings.options.axisY2.stripLines = lines;
}


Spectrum.prototype.reset = function(){
 this.calcDrawValues();
 this.SpectrumBarGraphCanvasSettings.render();
 //this.mainCanvasCtx.drawImage(this.SpectrumBarGraphCanvas,0,0,320,this.SpectrumBarGraphCanvas.height);
 //this.drawScale(this.Freq_From, this.Freq_To, this.ticks);
}
