function MorseNode(ac, rate) {
    // ac is an audio context.
    this._oscillator = ac.createOscillator();
    this._gain = ac.createGain();

    this._gain.gain.value = 0;
    this._oscillator.frequency.value = 800;

    this._oscillator.connect(this._gain);
    this.code = "";
    this.count = 0;
    this.stringlen = 0;
    if(rate == undefined)rate = 20;
    this._dot = 1.2 / rate; // formula from Wikipedia.
    this._oscillator.start(0);
}

MorseNode.prototype.connect = function(target) {
    return this._gain.connect(target);
}

MorseNode.prototype.MORSE = {
    "A": ".-",
    "B": "-...",
    "C": "-.-.",
    "D": "-..",
    "E": ".",
    "F": "..-.",
    "G": "--.",
    "H": "....",
    "I": "..",
    "J": ".---",
    "K": "-.-",
    "L": ".-..",
    "M": "--",
    "N": "-.",
    "O": "---",
    "P": ".--.",
    "Q": "--.-",
    "R": ".-.",
    "S": "...",
    "T": "-",
    "U": "..-",
    "V": "...-",
    "W": ".--",
    "X": "-..-",
    "Y": "-.--",
    "Z": "--..",

    "1": ".----",
    "2": "..---",
    "3": "...--",
    "4": "....-",
    "5": ".....",
    "6": "-....",
    "7": "--...",
    "8": "---..",
    "9": "----.",
    "0": "-----"
};


MorseNode.prototype.returnTime = function(){};

MorseNode.prototype.countTime = function(code){
    var time = 0;
    for(var i=0;i<code.length;i++){
        if(code[i] == "."){
            time+=this._dot;
        }else{
            time+=this._dot*3;
        }
        time+=this._dot*3;
    }
    this.returnTime(time);
}

MorseNode.prototype.playChar = function(t, c) {
    this.count++;
    for(var i = 0; i < c.length; i++) {
        switch(c[i]) {
        case '.':
            this._gain.gain.setValueAtTime(1.0, t);
            t += this._dot;
            this._gain.gain.setValueAtTime(0.0, t);
            break;
        case '-':
            this._gain.gain.setValueAtTime(1.0, t);
            t += 3 * this._dot;
            this._gain.gain.setValueAtTime(0.0, t);
            break;
        }
        t += this._dot;
        this.code+=c[i];
    }
    if(this.count == this.stringlen-1){
        this.countTime(this.code);
    }
    return t;
}

MorseNode.prototype.playString = function(t, w) {
	w.trim();
	w+= " QRSSB"
    w = w.toUpperCase();
    this.count = 0;
    this.code = "";
    this.stringlen = w.length;
    for(var i = 0; i < w.length; i++) {
        if(w[i] == ' ') {
            t += 3 * this._dot; // 3 dots from before, three here, and
                                // 1 from the ending letter before.
        }
        else if(this.MORSE[w[i]] != undefined) {
            t = this.playChar(t, this.MORSE[w[i]]);
            t += 2 * this._dot;
        }
    }
    return t;
}